﻿using System;
using System.Collections.Generic;
using System.Diagnostics;
using System.IO;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace Exam
{
    // Вклад
    public class Deposit
    {
        public double Value { get; set; }

        public Percent Percent { get; set; }

        public Deposit(double value)
        {
            Value = value;

            Percent = new Percent(Value);
        }

        public void Income()
        {
            double income = Math.Round(Value * Percent.Value, 2);
            if (Percent.Value <= 0.13)
                Value += income;
            else
                Value += income - 0.3 * income;
        }
    }

    // Процент
    public class Percent
    {
        public double Value { get; set; }

        public Percent(double value)
        {
            if (value < 700000.00)
                Value = Math.Round(value / 50000.00) / 100;
            else
            {
                if (Math.Round((value - 700000) / 50000.00) == (value - 700000) / 50000.00)
                    Value = 0.2 - Math.Round((value - 700000) / 50000.00 / 100.00, 3);
                else
                    Value = 0.2 - Math.Round((value - 700000) / 50000.00 / 100.00, 3) + 0.01;
            }

            if (Value < 0.01)
                Value = 0.01;
            if (Value > 0.2)
                Value = 0.2;
        }

        public void Raise()
        {
            if (Value < 0.2)
                Value += 0.005;
        }
    }

    class DebugListener
    {
        public DebugListener()
        {
            TextWriterTraceListener[] listeners = new TextWriterTraceListener[] {
                new TextWriterTraceListener($"{Directory.GetCurrentDirectory()}/debug.txt"),
                new TextWriterTraceListener(Console.Out)
            };
            Debug.Listeners.AddRange(listeners);
            Debug.Flush();
        }
    }

    internal class Program
    {
        static void Main(string[] args)
        {
            const double minDeposit = 49999.99;
            const double maxDeposit = 1000000.00;

            DebugListener debugListener = new DebugListener();

            double max = 0;
            double startDeposit = 0;

            List<Deposit> depositList = new List<Deposit>();
            List<double> startDeposits = new List<double>();

            for (double i = minDeposit; i < maxDeposit; i += 50000)
            {
                depositList.Add(new Deposit(i));
                startDeposits.Add(i);
            }
            depositList.Add(new Deposit(maxDeposit));
            startDeposits.Add(maxDeposit);

            for (int i = 1; i <= 12; i++)
            {
                foreach (Deposit deposit in depositList)
                {
                    // Повышение процента раз в три месяца
                    if (i % 3 == 0)
                        deposit.Percent.Raise();
                    // Вывод количества денег и процента
                    Debug.WriteLine($"{deposit.Value} // {deposit.Percent.Value}");
                    if (i != 12)
                        deposit.Income();
                }
                Debug.WriteLine("");
            }

            foreach (Deposit deposit in depositList)
                if (deposit.Value > max)
                {
                    max = deposit.Value;
                    startDeposit = startDeposits[depositList.IndexOf(deposit)];
                }

            using (StreamWriter streamWriter = new StreamWriter($"{Directory.GetCurrentDirectory()}/max.txt"))
            {
                streamWriter.WriteLine($"Наибольший совокупный доход равен {max} со стартовым вкладом {startDeposit}");
            }

            Console.Read();
        }
    }
}
